AJS.toInit(function() {
  var baseUrl = AJS.$("meta[name='application-base-url']").attr("content");
  
  // Setting the baseUrl meta tag in confluence is not working, but there is a provided
  // meta-tag called confluence-base-url that does the job.
  if(typeof baseUrl === "undefined") {
	  baseUrl = AJS.$("meta[name='confluence-base-url']").attr("content");
  }
  
  function disableForm() {
	  AJS.$(".disableable :input").prop('disabled',true);
	  AJS.$("#waitmessage").show();
  }
  
  function enableForm() {
	  AJS.$(".disableable :input").prop('disabled',false);
	  AJS.$("#waitmessage").hide();
  }
  
  function populateForm() {
	disableForm();
    AJS.$.ajax({
      url: baseUrl + "/rest/samlsso-admin/1.0/",
      dataType: "json",
      success: function(config) {
        AJS.$("#defaultredirecturl").attr("value", config.defaultredirecturl);
        AJS.$("#idpurl").attr("value", config.idpurl);
        AJS.$("#loginpageurl").attr("value", config.loginpageurl);
        AJS.$("#idpcertificate").attr("value", config.idpcertificate);
        AJS.$("#decodedcert").attr("value", config.decodedidpcertificate);
        AJS.$("#setloginurl").attr("checked", config.setloginurl);
        AJS.$("#overridelogouturl").attr("checked", config.overridelogouturl);
        AJS.$("#logoutUrl").attr("value", config.logoutUrl);
        AJS.$("#enableUserForLogin").attr("checked", config.enableUserForLogin);
        AJS.$("#redirectWithPOST").attr("checked", config.redirectWithPOST);
        AJS.$("#relaystateparametername").attr("value", config.relaystateparametername);
        AJS.$("#omitrequestedauthncontext").attr("checked", config.omitrequestedauthncontext);
        AJS.$("#jiraGroups").attr("value", config.jiraGroups);
        AJS.$("#licenseString").attr("value", config.licenseString);
        AJS.$("#useridTransformationRegex").attr("value", config.useridTransformationRegex);
        AJS.$("#useridTransformationReplacement").attr("value", config.useridTransformationReplacement);
        AJS.$("#errorpagetemplate").attr("value", config.errorPageTemplate);
        AJS.$("#loggedoutpagetemplate").attr("value", config.loggedoutPageTemplate);
        
        AJS.$("#licenseMessage").text(config.licenseMessage);
        if(config.licensed) {
        	 AJS.$("#licenseMessage").removeClass("error");
        	 AJS.$("#licenseMessage").addClass("success");
        } else {
        	 AJS.$("#licenseMessage").addClass("error");
        	 AJS.$("#licenseMessage").removeClass("success");
        	
        }
          
        enableForm();
      },
      error: function() {
    	  AJS.$("#aui-message-bar").empty(); 
    	  AJS.messages.error({
	    	    title: "Load failed",
	    	    body: "Loading settings failed!",
	    	    closeable: false
	    	});
      }
    });
  }
  
  function updateConfig() {
	  disableForm();
	  var ajaxdata = { 
		  "idpurl": 			AJS.$("#idpurl").attr("value"), 
		  "defaultredirecturl": AJS.$("#defaultredirecturl").attr("value"),
		  "loginpageurl":  		AJS.$("#loginpageurl").attr("value"),
		  "idpcertificate":  	AJS.$("#idpcertificate").attr("value"),
		  "jiraGroups":         AJS.$("#jiraGroups").attr("value"),
		  "setloginurl":      	(AJS.$("#setloginurl:checked").length > 0),
		  "overridelogouturl":  (AJS.$("#overridelogouturl:checked").length > 0),
		  "logoutUrl":          AJS.$("#logoutUrl").attr("value"), 
		  "licenseString":      AJS.$("#licenseString").attr("value"), 
		  "omitrequestedauthncontext": (AJS.$("#omitrequestedauthncontext:checked").length > 0),
		  "enableUserForLogin": (AJS.$("#enableUserForLogin:checked").length > 0),
		  "redirectWithPOST": (AJS.$("#redirectWithPOST:checked").length > 0),
		  "relaystateparametername":  AJS.$("#relaystateparametername").attr("value"),
		  "useridTransformationRegex": AJS.$("#useridTransformationRegex").attr("value"),
		  "useridTransformationReplacement": AJS.$("#useridTransformationReplacement").attr("value"),
		  "errorPageTemplate": AJS.$("#errorpagetemplate").attr("value"),
		  "loggedoutPageTemplate": AJS.$("#loggedoutpagetemplate").attr("value")	  
	  }
	  
	  
	  AJS.$.ajax({
	    url: baseUrl + "/rest/samlsso-admin/1.0/",
	    type: "PUT",
	    contentType: "application/json; charset=utf-8",
	    data: JSON.stringify(ajaxdata),
	    processData: true,
	    success: function () { 
	    	AJS.$("#aui-message-bar").empty(); 
	    	AJS.messages.success({
	    	    title: "Saved",
	    	    body: "Settings saved successfully.",
	    	    closeable: false
	    	});
	    	populateForm();
	    },
	    error: function() { 
	    	AJS.$("#aui-message-bar").empty(); 
	    	AJS.messages.error({
	    	    title: "Save failed",
	    	    body: "Saving Settings failed!",
	    	    closeable: false
	    	}); 
	    	populateForm();
	    }
	  });  
	}
     
  populateForm();
  
  AJS.$("#admin").submit(function(e) {
	    e.preventDefault();
	    updateConfig();
	});
  
  AJS.$("#cancel").click(function(e) {
	    e.preventDefault();
	    AJS.$("#aui-message-bar").empty(); 
	    populateForm();
	});
  
});

/*
*  Escape newline chars for being transmitted with JSON over the wire
*/
function escapeNewLineChars(valueToEscape) {
    if (valueToEscape != null && valueToEscape != "") {
        return valueToEscape.replace(/\n/g, "\\n");
    } else {
        return valueToEscape;
    }
}
